unit Unit1;

//Programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Palette: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Panel3: TPanel;
    Label1: TLabel;
    ColorDialog1: TColorDialog;
    procedure PaletteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaletteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1DblClick(Sender: TObject);
    procedure Panel2DblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PaletteMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Panel3.Color:=Palette.Canvas.Pixels[x,y];
//affiche dans le panel3 la couleur de la palette

label1.caption:='R : ' +inttostr(GetrValue(Panel3.Color))+
#13'V : ' +inttostr(GetgValue(Panel3.Color))+#13+ 'B : ' +inttostr(GetbValue(Panel3.Color));

//cette fonction permet d'afficher le RGB de la couleur.
//#13 permet d'aller a la ligne
end;

procedure TForm1.PaletteMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if ssLeft in Shift then
begin
Panel1.Color:=Palette.Canvas.Pixels[x,y];
//affiche dans le panel1 au clic gauche de la souris la couleur de la palette
end;

if ssRight in Shift then
begin
Panel2.Color:=Palette.Canvas.Pixels[x,y];
//affiche dans le panel2 au clic droit de la souris la couleur de la palette
end;

end;

procedure TForm1.Panel1DblClick(Sender: TObject);
begin
//La couleur du panel1 est celle de la boite de couleur en l'ouvrant
ColorDialog1.Color:=Panel1.Color;
if ColorDialog1.Execute then
begin
//Si l'utilisateur clique sur le bouton OK de la boite de dialogue alors sa
//couleur s'affichera dans le Panel1
Panel1.Color:=ColorDialog1.Color;
end;

end;

procedure TForm1.Panel2DblClick(Sender: TObject);
begin
//La couleur du panel2 est celle de la boite de couleur en l'ouvrant
ColorDialog1.Color:=Panel2.Color;
if ColorDialog1.Execute then
begin
//Si l'utilisateur clique sur le bouton OK de la boite de dialogue alors sa
//couleur s'affichera dans le Panel2
Panel2.Color:=ColorDialog1.Color;
end;

end;

end.
